ompi/mca/btl/btl.h File Reference.TH "ompi/mca/btl/btl.h" 3 "7 Dec 2005" "Version 0.1.1" "OpenMPI" \" -*- nroff -*-
.ad l
.nh
.SH NAME
ompi/mca/btl/btl.h \- Bit Mover Interface (BTL). 
.SH SYNOPSIS
.br
.PP
\fC#include 'mca/mca.h'\fP
.br
\fC#include 'include/types.h'\fP
.br
\fC#include 'class/ompi_free_list.h'\fP
.br

.SS "Defines"

.in +1c
.ti -1c
.RI "#define \fBMCA_BTL_TAG_BTL\fP   0"
.br
.ti -1c
.RI "#define \fBMCA_BTL_TAG_PML\fP   1"
.br
.ti -1c
.RI "#define \fBMCA_BTL_TAG_USR\fP   2"
.br
.ti -1c
.RI "#define \fBMCA_BTL_TAG_MAX\fP   255"
.br
.ti -1c
.RI "#define \fBMCA_BTL_FLAGS_SEND\fP   0x1"
.br
.ti -1c
.RI "#define \fBMCA_BTL_FLAGS_PUT\fP   0x2"
.br
.ti -1c
.RI "#define \fBMCA_BTL_FLAGS_GET\fP   0x4"
.br
.ti -1c
.RI "#define \fBMCA_BTL_FLAGS_RDMA\fP   (MCA_BTL_FLAGS_GET|MCA_BTL_FLAGS_PUT)"
.br
.ti -1c
.RI "#define \fBMCA_BTL_FLAGS_SEND_INPLACE\fP   0x8"
.br
.ti -1c
.RI "#define \fBMCA_BTL_FLAGS_RELIABLE\fP   0x10"
.br
.ti -1c
.RI "#define \fBMCA_BTL_EXCLUSIVITY_HIGH\fP   64*1024"
.br
.ti -1c
.RI "#define \fBMCA_BTL_EXCLUSIVITY_DEFAULT\fP   1024"
.br
.ti -1c
.RI "#define \fBMCA_BTL_EXCLUSIVITY_LOW\fP   0"
.br
.ti -1c
.RI "#define \fBMCA_BTL_DES_FLAGS_DEREGISTER\fP   0x0001"
.br
.ti -1c
.RI "#define \fBMCA_BTL_DES_FLAGS_PRIORITY\fP   0x0002"
.br
.ti -1c
.RI "#define \fBMCA_BTL_DES_MAX_SEGMENTS\fP   16"
.br
.RI "\fIMaximum number of allowed segments in src/dst fields of a descriptor. \fP"
.ti -1c
.RI "#define \fBMCA_BTL_BASE_VERSION_1_0_0\fP"
.br
.in -1c
.SS "Typedefs"

.in +1c
.ti -1c
.RI "typedef void(* \fBmca_btl_base_completion_fn_t\fP )(struct \fBmca_btl_base_module_t\fP *, struct \fBmca_btl_base_endpoint_t\fP *, struct \fBmca_btl_base_descriptor_t\fP *, int status)"
.br
.RI "\fIAsynchronous callback function on completion of an operation. \fP"
.ti -1c
.RI "typedef \fBmca_btl_base_segment_t\fP \fBmca_btl_base_segment_t\fP"
.br
.ti -1c
.RI "typedef \fBmca_btl_base_descriptor_t\fP \fBmca_btl_base_descriptor_t\fP"
.br
.ti -1c
.RI "typedef mca_btl_base_header_t \fBmca_btl_base_header_t\fP"
.br
.ti -1c
.RI "typedef \fBmca_btl_base_module_t\fP **(* \fBmca_btl_base_component_init_fn_t\fP )(int *num_btls, bool enable_progress_threads, bool enable_mpi_threads)"
.br
.RI "\fIMCA->BTL Initializes the BTL component and creates specific BTL module(s). \fP"
.ti -1c
.RI "typedef int(* \fBmca_btl_base_component_progress_fn_t\fP )(void)"
.br
.RI "\fIMCA->BTL Called to progress outstanding requests for non-threaded polling environments. \fP"
.ti -1c
.RI "typedef \fBmca_btl_base_component_1_0_0_t\fP \fBmca_btl_base_component_1_0_0_t\fP"
.br
.ti -1c
.RI "typedef \fBmca_btl_base_component_1_0_0_t\fP \fBmca_btl_base_component_t\fP"
.br
.ti -1c
.RI "typedef int(* \fBmca_btl_base_module_finalize_fn_t\fP )(struct \fBmca_btl_base_module_t\fP *btl)"
.br
.RI "\fIMCA->BTL Clean up any resources held by BTL module before the module is unloaded. \fP"
.ti -1c
.RI "typedef int(* \fBmca_btl_base_module_add_procs_fn_t\fP )(struct \fBmca_btl_base_module_t\fP *btl, size_t nprocs, struct ompi_proc_t **procs, struct \fBmca_btl_base_endpoint_t\fP **endpoints, struct ompi_bitmap_t *reachable)"
.br
.RI "\fIPML->BTL notification of change in the process list. \fP"
.ti -1c
.RI "typedef int(* \fBmca_btl_base_module_del_procs_fn_t\fP )(struct \fBmca_btl_base_module_t\fP *btl, size_t nprocs, struct ompi_proc_t **procs, struct \fBmca_btl_base_endpoint_t\fP **)"
.br
.RI "\fINotification of change to the process list. \fP"
.ti -1c
.RI "typedef void(* \fBmca_btl_base_module_recv_cb_fn_t\fP )(struct \fBmca_btl_base_module_t\fP *btl, mca_btl_base_tag_t tag, \fBmca_btl_base_descriptor_t\fP *descriptor, void *cbdata)"
.br
.RI "\fICallback function that is called asynchronously on receipt of data by the transport layer. \fP"
.ti -1c
.RI "typedef int(* \fBmca_btl_base_module_register_fn_t\fP )(struct \fBmca_btl_base_module_t\fP *btl, mca_btl_base_tag_t tag, \fBmca_btl_base_module_recv_cb_fn_t\fP cbfunc, void *cbdata)"
.br
.RI "\fIRegister a callback function that is called on receipt of a fragment. \fP"
.ti -1c
.RI "typedef \fBmca_btl_base_descriptor_t\fP *(* \fBmca_btl_base_module_alloc_fn_t\fP )(struct \fBmca_btl_base_module_t\fP *btl, size_t size)"
.br
.RI "\fIAllocate a descriptor with a segment of the requested size. \fP"
.ti -1c
.RI "typedef int(* \fBmca_btl_base_module_free_fn_t\fP )(struct \fBmca_btl_base_module_t\fP *btl, \fBmca_btl_base_descriptor_t\fP *descriptor)"
.br
.RI "\fIReturn a descriptor allocated from this BTL via alloc/prepare. \fP"
.ti -1c
.RI "typedef \fBmca_btl_base_descriptor_t\fP *(* \fBmca_btl_base_module_prepare_fn_t\fP )(struct \fBmca_btl_base_module_t\fP *btl, struct \fBmca_btl_base_endpoint_t\fP *endpoint, mca_mpool_base_registration_t *registration, struct ompi_convertor_t *convertor, size_t reserve, size_t *size)"
.br
.RI "\fIPrepare a descriptor for send/rdma using the supplied convertor. \fP"
.ti -1c
.RI "typedef int(* \fBmca_btl_base_module_send_fn_t\fP )(struct \fBmca_btl_base_module_t\fP *btl, struct \fBmca_btl_base_endpoint_t\fP *endpoint, struct \fBmca_btl_base_descriptor_t\fP *descriptor, mca_btl_base_tag_t tag)"
.br
.RI "\fIInitiate an asynchronous send. \fP"
.ti -1c
.RI "typedef int(* \fBmca_btl_base_module_put_fn_t\fP )(struct \fBmca_btl_base_module_t\fP *btl, struct \fBmca_btl_base_endpoint_t\fP *endpoint, struct \fBmca_btl_base_descriptor_t\fP *descriptor)"
.br
.RI "\fIInitiate an asynchronous put. \fP"
.ti -1c
.RI "typedef int(* \fBmca_btl_base_module_get_fn_t\fP )(struct \fBmca_btl_base_module_t\fP *btl, struct \fBmca_btl_base_endpoint_t\fP *endpoint, struct \fBmca_btl_base_descriptor_t\fP *descriptor)"
.br
.RI "\fIInitiate an asynchronous get. \fP"
.ti -1c
.RI "typedef \fBmca_btl_base_module_t\fP \fBmca_btl_base_module_t\fP"
.br
.in -1c
.SS "Functions"

.in +1c
.ti -1c
.RI "\fBOBJ_CLASS_DECLARATION\fP (\fBmca_btl_base_descriptor_t\fP)"
.br
.in -1c
.SS "Variables"

.in +1c
.ti -1c
.RI "struct struct struct struct typedef uint8_t \fBmca_btl_base_tag_t\fP"
.br
.in -1c
.SH "Detailed Description"
.PP 
Bit Mover Interface (BTL). 

BTL Initialization:
.PP
During library initialization, all available BTL components are loaded and opened via their mca_base_open_component_fn_t function. The BTL open function should register any mca parameters used to tune/adjust the behaviour of the BTL (\fBmca_base_param_register_int()\fP, \fBmca_base_param_register_string()\fP). Note that the open function may fail if the resources (e.g. shared libraries, etc) required by the network transport are not available.
.PP
The \fBmca_btl_base_component_init_fn_t()\fP is then called for each of the components that are succesfully opened. The component init function may return either:
.PP
(1) a NULL list of BTL modules if the transport is not available, (2) a list containing a single BTL module, where the BTL provides a layer of abstraction over multiple physical devices (e.g. NICs), (3) a list containing multiple BTL modules where each BTL module corresponds to a single physical device.
.PP
During module initialization, the module should post any addressing information required by its peers. An example would be the TCP listen port opened by the TCP module for incoming connection requests. This information is published to peers via the \fBmca_pml_base_modex_send()\fP interface. Note that peer information is not guaranteed to be available via \fBmca_pml_base_modex_recv()\fP during the module's init function. However, it will be available during BTL selection (mca_btl_base_add_proc_fn_t()).
.PP
BTL Selection:
.PP
The upper layer builds an ordered list of the available BTL modules sorted by their exclusivity ranking. This is a relative ranking that is used to determine the set of BTLs that may be used to reach a given destination. During startup the BTL modules are queried via their mca_btl_base_add_proc_fn_t() to determine if they are able to reach a given destination. The BTL module with the highest ranking that returns success is selected. Subsequent BTL modules are selected only if they have the same exclusivity ranking.
.PP
An example of how this might be used:
.PP
BTL Exclusivity Comments -------- ----------- ------------------ LO 100 Selected exclusively for local process SM 50 Selected exclusively for other processes on host IB 0 Selected based on network reachability IB 0 Selected based on network reachability TCP 0 Selected based on network reachability TCP 0 Selected based on network reachability
.PP
When a BTL module is selected, it may choose to optionally return a pointer to an an \fBmca_btl_base_endpoint_t\fP data structure to the PML. This pointer is treated as an opaque handle by the PML and is returned to the BTL on subsequent data transfer calls to the corresponding destination process. The actual contents of the data structure are defined on a per BTL basis, and may be used to cache addressing or connection information, such as a TCP socket or IB queue pair.
.PP
Progress:
.PP
By default, the library provides for polling based progress of outstanding requests. The BTL component exports an interface function (btlm_progress) that is called in a polling mode by the PML during calls into the MPI library. Note that the btlm_progress() function is called on the BTL component rather than each BTL module. This implies that the BTL author is responsible for iterating over the pending operations in each of the BTL modules associated with the component.
.PP
On platforms where threading support is provided, the library provides the option of building with asynchronous threaded progress. In this case, the BTL author is responsible for providing a thread to progress pending operations. A thread is associated with the BTL component/module such that transport specific functionality/APIs may be used to block the thread ubtll a pending operation completes. This thread MUST NOT poll for completion as this would oversubscribe the CPU.
.PP
Note that in the threaded case the PML may choose to use a hybrid approach, such that polling is implemented from the user thread for a fixed number of cycles before relying on the background thread(s) to complete requests. If possible the BTL should support the use of both modes concurrebtly.
.SH "Define Documentation"
.PP 
.SS "#define MCA_BTL_BASE_VERSION_1_0_0"
.PP
\fBValue:\fP
.PP
.nf
/* coll v1.0 is chained to MCA v1.0 */ \
  MCA_BASE_VERSION_1_0_0, \
  /* btl v1.0 */ \
  'btl', 1, 0, 0
.fi
.SH "Typedef Documentation"
.PP 
.SS "typedef struct \fBmca_btl_base_module_t\fP**(* \fBmca_btl_base_component_init_fn_t\fP)(int *num_btls, bool enable_progress_threads, bool enable_mpi_threads)"
.PP
MCA->BTL Initializes the BTL component and creates specific BTL module(s). 
.PP
\fBParameters:\fP
.RS 4
\fInum_btls\fP (OUT) Returns the number of btl modules created, or 0 if the transport is not available.
.br
\fIenable_progress_threads\fP (IN) Whether this component is allowed to run a hidden/progress thread or not.
.br
\fIenable_mpi_threads\fP (IN) Whether support for multiple MPI threads is enabled or not (i.e., MPI_THREAD_MULTIPLE), which indicates whether multiple threads may invoke this component simultaneously or not.
.RE
.PP
\fBReturns:\fP
.RS 4
Array of pointers to BTL modules, or NULL if the transport is not available.
.RE
.PP
During component initialization, the BTL component should discover the physical devices that are available for the given transport, and create a BTL module to represent each device. Any addressing information required by peers to reach the device should be published during this function via the \fBmca_pml_base_modex_send()\fP interface. 
.SS "typedef int(* \fBmca_btl_base_component_progress_fn_t\fP)(void)"
.PP
MCA->BTL Called to progress outstanding requests for non-threaded polling environments. 
.PP
\fBParameters:\fP
.RS 4
\fItstamp\fP Current time. 
.RE
.PP
\fBReturns:\fP
.RS 4
OMPI_SUCCESS or error code on failure. 
.RE
.PP

.SS "typedef int(* \fBmca_btl_base_module_add_procs_fn_t\fP)(struct \fBmca_btl_base_module_t\fP *btl, size_t nprocs, struct ompi_proc_t **procs, struct \fBmca_btl_base_endpoint_t\fP **endpoints, struct ompi_bitmap_t *reachable)"
.PP
PML->BTL notification of change in the process list. 
.PP
\fBParameters:\fP
.RS 4
\fIbtl\fP (IN) BTL module 
.br
\fInprocs\fP (IN) Number of processes 
.br
\fIprocs\fP (IN) Set of processes 
.br
\fIendpoint\fP (OUT) Set of (optional) \fBmca_btl_base_endpoint_t\fP structures by BTL. 
.br
\fIreachable\fP (OUT) Bitmask indicating set of peer processes that are reachable by this BTL. 
.RE
.PP
\fBReturns:\fP
.RS 4
OMPI_SUCCESS or error status on failure.
.RE
.PP
The \fBmca_btl_base_module_add_procs_fn_t()\fP is called by the PML to determine the set of BTLs that should be used to reach each process. Any addressing information exported by the peer via the \fBmca_pml_base_modex_send()\fP function should be available during this call via the corresponding \fBmca_pml_base_modex_recv()\fP function. The BTL may utilize this information to determine reachability of each peer process.
.PP
For each process that is reachable by the BTL, the bit corresponding to the index into the proc array (nprocs) should be set in the reachable bitmask. The PML provides the BTL the option to return a pointer to a data structure defined by the BTL that is returned to the BTL on subsequent calls to the BTL data transfer functions (e.g btl_send). This may be used by the BTL to cache any addressing or connection information (e.g. TCP socket, IP queue pair). 
.SS "typedef \fBmca_btl_base_descriptor_t\fP*(* \fBmca_btl_base_module_alloc_fn_t\fP)(struct \fBmca_btl_base_module_t\fP *btl, size_t size)"
.PP
Allocate a descriptor with a segment of the requested size. 
.PP
Note that the BTL layer may choose to return a smaller size if it cannot support the request.
.PP
\fBParameters:\fP
.RS 4
\fIbtl\fP (IN) BTL module 
.br
\fIsize\fP (IN) Request segment size. 
.RE
.PP

.SS "typedef int(* \fBmca_btl_base_module_del_procs_fn_t\fP)(struct \fBmca_btl_base_module_t\fP *btl, size_t nprocs, struct ompi_proc_t **procs, struct \fBmca_btl_base_endpoint_t\fP **)"
.PP
Notification of change to the process list. 
.PP
\fBParameters:\fP
.RS 4
\fIbtl\fP (IN) BTL module 
.br
\fInprocs\fP (IN) Number of processes 
.br
\fIproc\fP (IN) Set of processes 
.br
\fIpeer\fP (IN) Set of peer addressing information. 
.RE
.PP
\fBReturns:\fP
.RS 4
Status indicating if cleanup was successful
.RE
.PP
When the process list changes, the PML notifies the BTL of the change, to provide the opportunity to cleanup or release any resources associated with the peer. 
.SS "typedef int(* \fBmca_btl_base_module_finalize_fn_t\fP)(struct \fBmca_btl_base_module_t\fP *btl)"
.PP
MCA->BTL Clean up any resources held by BTL module before the module is unloaded. 
.PP
\fBParameters:\fP
.RS 4
\fIbtl\fP (IN) BTL module.
.RE
.PP
Prior to unloading a BTL module, the MCA framework will call the BTL finalize method of the module. Any resources held by the BTL should be released and if required the memory corresponding to the BTL module freed. 
.SS "typedef int(* \fBmca_btl_base_module_free_fn_t\fP)(struct \fBmca_btl_base_module_t\fP *btl, \fBmca_btl_base_descriptor_t\fP *descriptor)"
.PP
Return a descriptor allocated from this BTL via alloc/prepare. 
.PP
\fBParameters:\fP
.RS 4
\fIbtl\fP (IN) BTL module 
.br
\fIsegment\fP (IN) Descriptor allocated from the BTL 
.RE
.PP

.SS "typedef int(* \fBmca_btl_base_module_get_fn_t\fP)(struct \fBmca_btl_base_module_t\fP *btl, struct \fBmca_btl_base_endpoint_t\fP *endpoint, struct \fBmca_btl_base_descriptor_t\fP *descriptor)"
.PP
Initiate an asynchronous get. 
.PP
\fBParameters:\fP
.RS 4
\fIbtl\fP (IN) BTL module 
.br
\fIendpoint\fP (IN) BTL addressing information 
.br
\fIdescriptor\fP (IN) Description of the data to be transferred 
.RE
.PP

.SS "typedef struct \fBmca_btl_base_descriptor_t\fP*(* \fBmca_btl_base_module_prepare_fn_t\fP)(struct \fBmca_btl_base_module_t\fP *btl, struct \fBmca_btl_base_endpoint_t\fP *endpoint, mca_mpool_base_registration_t *registration, struct ompi_convertor_t *convertor, size_t reserve, size_t *size)"
.PP
Prepare a descriptor for send/rdma using the supplied convertor. 
.PP
If the convertor references data that is contigous, the descriptor may simply point to the user buffer. Otherwise, this routine is responsible for allocating buffer space and packing if required.
.PP
\fBParameters:\fP
.RS 4
\fIbtl\fP (IN) BTL module 
.br
\fIendpoint\fP (IN) BTL peer addressing 
.br
\fIconvertor\fP (IN) Data type convertor 
.br
\fIreserve\fP (IN) Additional bytes requested by upper layer to precede user data 
.br
\fIsize\fP (IN/OUT) Number of bytes to prepare (IN), number of bytes actually prepared (OUT) 
.RE
.PP

.SS "typedef int(* \fBmca_btl_base_module_put_fn_t\fP)(struct \fBmca_btl_base_module_t\fP *btl, struct \fBmca_btl_base_endpoint_t\fP *endpoint, struct \fBmca_btl_base_descriptor_t\fP *descriptor)"
.PP
Initiate an asynchronous put. 
.PP
\fBParameters:\fP
.RS 4
\fIbtl\fP (IN) BTL module 
.br
\fIendpoint\fP (IN) BTL addressing information 
.br
\fIdescriptor\fP (IN) Description of the data to be transferred 
.RE
.PP

.SS "typedef int(* \fBmca_btl_base_module_register_fn_t\fP)(struct \fBmca_btl_base_module_t\fP *btl, mca_btl_base_tag_t tag, \fBmca_btl_base_module_recv_cb_fn_t\fP cbfunc, void *cbdata)"
.PP
Register a callback function that is called on receipt of a fragment. 
.PP
\fBParameters:\fP
.RS 4
\fIbtl\fP (IN) BTL module 
.RE
.PP
\fBReturns:\fP
.RS 4
Status indicating if cleanup was successful
.RE
.PP
When the process list changes, the PML notifies the BTL of the change, to provide the opportunity to cleanup or release any resources associated with the peer. 
.SS "typedef int(* \fBmca_btl_base_module_send_fn_t\fP)(struct \fBmca_btl_base_module_t\fP *btl, struct \fBmca_btl_base_endpoint_t\fP *endpoint, struct \fBmca_btl_base_descriptor_t\fP *descriptor, mca_btl_base_tag_t tag)"
.PP
Initiate an asynchronous send. 
.PP
\fBParameters:\fP
.RS 4
\fIbtl\fP (IN) BTL module 
.br
\fIendpoint\fP (IN) BTL addressing information 
.br
\fIdescriptor\fP (IN) Description of the data to be transfered 
.br
\fItag\fP (IN) The tag value used to notify the peer. 
.RE
.PP

.SH "Author"
.PP 
Generated automatically by Doxygen for OpenMPI from the source code.
